$regfile = "attiny13.dat"
$hwstack = 10
$swstack = 16
$framesize = 32
$crystal = 9600000

'final use pwm mode of timer0
'Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Down
                                            '
'=====================================================
Ws_2812 Alias Portb.2
Ws_2812_r Alias Portb.3
Clock_in Alias Portb.4

Config Ws_2812 = Output                                     ' 
Config Ws_2812_r = Output
Config Clock_in = Input

Const Divider = 30                                          '   60 

Dim Moment As Byte                                          '
Dim Startpoint As Byte                                      '  
Dim I As Byte

Moment = 0
Startpoint = 0
                                                    '
Declare Sub Reset_led
Declare Sub Reset_led_r
Declare Sub L_0
Declare Sub R_0
Declare Sub L_1
Declare Sub R_1
Declare Sub L_on
Declare Sub R_on
Declare Sub L_off
Declare Sub R_off
Declare Sub Red
Declare Sub Red_r
Declare Sub Green
Declare Sub Green_r
'Declare Sub Blue
'Declare Sub Yellow
'Declare Sub Violet
'Declare Sub Water
'Declare Sub White
Declare Sub Black
Declare Sub Black_r

'=======================================================

Do

Call Reset_led
Call Reset_led_r

Strt:

Call Black
Set Ws_2812
Call Black_r
Set Ws_2812_r
Incr Moment
If Moment < Divider Then
Waitms 1
Goto Strt
End If
Moment = 0

Call Reset_led
Call Reset_led_r

Paint:
Call Green
Set Ws_2812
Waitms 440
Call Green_r
Set Ws_2812_r
Waitms 440
Incr Moment
If Moment < Divider Then
Goto Paint
End If
Moment = 0

Call Reset_led
Call Reset_led_r

Loop

'===========================          =============================

'================================
Sub Reset_led                                               ' 
                                                            '
Reset Ws_2812
Waitus 600
Set Ws_2812

End Sub
'================================
Sub Reset_led_r                                             ' 
                                                            '
Reset Ws_2812_r
Waitus 600
Set Ws_2812_r

End Sub
'================================
Sub L_0
                                                     '  
Set Ws_2812 : Nop : Nop                                     '  9.6MHz  400nS
Reset Ws_2812 : Nop : Nop : Nop                             '  9.6MHz  800nS

End Sub
'================================
Sub R_0
                                                     '  
Set Ws_2812_r : Nop : Nop                                   '  9.6MHz  400nS
Reset Ws_2812_r : Nop : Nop : Nop                           '  9.6MHz  800nS

End Sub
'================================
Sub L_1
                                                     ' 
Set Ws_2812 : Nop : Nop : Nop                               '  9.6MHz  800nS
Reset Ws_2812 : Nop : Nop                                   '  9.6MHz  400nS

End Sub
'================================
Sub R_1
                                                     ' 
Set Ws_2812_r : Nop : Nop : Nop                             '  9.6MHz  800nS
Reset Ws_2812_r : Nop : Nop                                 '  9.6MHz  400nS

End Sub
'================================
Sub L_off                                                   '  

Call L_0                                                    ' =
Call L_0                                                    '
Call L_0                                                    '  
Call L_0                                                    '
Call L_0                                                    '
Call L_0                                                    '
Call L_0                                                    '
Call L_0

End Sub
'================================
Sub R_off                                                   '  

Call R_0                                                    ' =
Call R_0                                                    '
Call R_0                                                    '  
Call R_0                                                    '
Call R_0                                                    '
Call R_0                                                    '
Call R_0                                                    '
Call R_0

End Sub
'================================
Sub L_on                                                    '  

Call L_1                                                    ' =
Call L_1                                                    '
Call L_1                                                    '  
Call L_1                                                    '
Call L_1                                                    '
Call L_1                                                    '
Call L_1                                                    '
Call L_1                                                    ' =

End Sub
'================================
Sub R_on                                                    '  

Call R_1                                                    ' =
Call R_1                                                    '
Call R_1                                                    '  
Call R_1                                                    '
Call R_1                                                    '
Call R_1                                                    '
Call R_1                                                    '
Call R_1                                                    ' =

End Sub
'================================
Sub Green

Call L_on                                                   ' =
Call L_off                                                  '  
Call L_off                                                  ' =

End Sub
'================================
Sub Green_r

Call R_on                                                   ' =
Call R_off                                                  '  
Call R_off                                                  ' =

End Sub
'===============================
Sub Red

Call L_off                                                  ' =
Call L_on                                                   '  
Call L_off                                                  ' =

End Sub
'================================
Sub Red_r

Call R_off                                                  ' =
Call R_on                                                   '  
Call R_off                                                  ' =

End Sub
'================================
'Sub Blue

'Call L_off                                                  ' =
'Call L_off                                                  '  
'Call L_on                                                   ' =

'End Sub
'================================
'Sub Yellow

'Call L_on                                                   ' =
'Call L_on                                                   '  
'Call L_off                                                  ' =

'End Sub
'================================
'Sub Violet

'Call L_off                                                  ' =
'Call L_on                                                   '  
'Call L_on                                                   ' =

'End Sub
'================================
'Sub Water

'Call L_on                                                   ' =
'Call L_off                                                  '  
'Call L_on                                                   ' =

'End Sub
'================================
'Sub White

'Call L_on                                                   ' =
'Call L_on                                                   '  
'Call L_on                                                   ' =

'End Sub
'================================
Sub Black

Call L_off                                                  ' =
Call L_off                                                  '  
Call L_off                                                  ' =

End Sub
'================================
Sub Black_r

Call R_off                                                  ' =
Call R_off                                                  '  
Call R_off                                                  ' =

End Sub
'================================

'================================
End